(* colcom -- solve the colorful components problem
   Copyright (C) 2011  Falk Hüffner

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.  *)

type 'a t = 'a list * 'a list;;

let empty = [], [];;

let push (input, output) item = (item::input, output);;

let is_empty = function
  | [], [] -> true
  | _ -> false
;;

let rec pop = function
  | input, item :: output -> item, (input, output)
  | [], [] -> failwith "Queue.pop"
  | input, [] -> pop ([], List.rev input)
;;
