(* colcom -- solve the colorful components problem
   Copyright (C) 2011  Falk Hüffner

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.  *)

(** Functiona queues.  *)

(** The type of the queue.  *)
type 'a t

(** The empty queue.  *)
val empty : 'a t

(** Add an entry to the queue.  *)
val push : 'a t -> 'a -> 'a t

(** Check if the queue is empty.  *)
val is_empty : 'a t -> bool

(** Return head of queue and queue without head.  *)
val pop : 'a t -> 'a * 'a t
